function result_struct = compress_result_struct(result_struct);
% function result_struct = compress_result_struct(result_struct);
%
% CVS_Version_String = '$Id: compress_result_struct.m,v 1.5 2003/12/05 23:41:04 tuerk Exp $';
% CVS_Name_String = '$Name: rel-1-4-01 $';

% ###########################################################
%
% This file is part of the matlab scripts of the MASV System.
% MASV = Munich Automatic Speaker Verification
%
% Copyright 2002-2003, Ulrich Trk
% Institute of Phonetics and Speech Communication
% University of Munich
% tuerk@phonetik.uni-muenchen.de
%
%
%   MASV is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
%
%   MASV is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with MASV; if not, write to the Free Software
%   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
%
% ###########################################################




	if (isfield(result_struct.FR_struct{1}.data(1).mlf_data, 'start_vector')),
	
		for model=1:length(result_struct.FR_struct),
				tmp_mlf_data = rmfield(result_struct.FR_struct{model}.data.mlf_data,'start_vector');
				result_struct.FR_struct{model}.data.mlf_data = rmfield(tmp_mlf_data,'phoneme_vector');
		end
		clear rmfield;
		for model=1:length(result_struct.FA_struct),
				tmp_mlf_data = rmfield(result_struct.FA_struct{model}.data.mlf_data,'start_vector');
				result_struct.FA_struct{model}.data.mlf_data = rmfield(tmp_mlf_data,'phoneme_vector');
				clear rmfield;
		end
	end
	return;
	if (isfield(result_struct, 'worlddata')),
		for model=1:length(result_struct.worlddata.modeldata),
			if (isfield(result_struct.worlddata.modeldata{1}, 'mlf_data')),
					tmp_mlf_data = rmfield(result_struct.worlddata.modeldata{model}.data.mlf_data,'start_vector');
					result_struct.worlddata.modeldata{model}.data.mlf_data = rmfield(tmp_mlf_data,'phoneme_vector');
			end
		end
		clear rmfield;
		for model=1:length(result_struct.worlddata.impdata),
			if (isfield(result_struct.worlddata.impdata{1}, 'mlf_data')),
					tmp_mlf_data = rmfield(result_struct.worlddata.impdata{model}.data.mlf_data,'start_vector');
					result_struct.worlddata.impdata{model}.data.mlf_data = rmfield(tmp_mlf_data,'phoneme_vector');
			end
		end
		clear rmfield;
	end
	

